<template>
  <div class="modal-bg" :style="bgStyle" @click.self="close">
    <div class="modal" :style="dialogStyle">
      <slot />
      <button
        class="close-button"
        @click="close"
        v-html="UNICODE.CLOSE"
      ></button>
    </div>
  </div>
</template>

<script setup lang="ts">
import { computed, type StyleValue } from 'vue'
import { EVENTS, UNICODE } from '@/utils/constants'

const emits = defineEmits([EVENTS.CLOSE])
const props = defineProps({
  dialog: Boolean
})

const getStyle = () => {
  const { dialog } = props
  const opacity = dialog ? 1 : 0
  const pointerEvents = dialog ? 'all' : 'none'
  const transform = `scale(${opacity})`
  return { opacity, pointerEvents, transform }
}

const bgStyle = computed((): StyleValue => {
  const { opacity, pointerEvents } = getStyle()
  return { opacity, pointerEvents } as StyleValue
})

const dialogStyle = computed((): StyleValue => {
  const { pointerEvents, transform } = getStyle()
  return { pointerEvents, transform } as StyleValue
})

const close = (): void => emits(EVENTS.CLOSE)
</script>

<style scoped>
.modal-bg {
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  display: flex;
  justify-content: center;
  align-items: center;
  background-color: #555a;
  transition: all 0.2s;
}
.modal {
  width: 100vw;
  height: 100vh;
  overflow-y: auto;
  padding: 20px;
  background-color: var(--color-background-soft);
  box-shadow: 0px 0px 8px #2226;
  transition: all 0.2s ease-in-out;
}
.close-button {
  width: 36px;
  height: 36px;
  position: fixed;
  top: 0;
  right: 0;
}
@media (prefers-color-scheme: dark) {
  .modal-bg {
    background-color: #000c;
  }
}
@media screen and (min-width: 768px) {
  .modal {
    width: 60vw;
    height: auto;
    max-height: 90vh;
  }
  .close-button {
    position: absolute;
  }
}
</style>
